from __future__ import annotations

from collections.abc import Mapping
from typing import TYPE_CHECKING, Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.bound_data import BoundData


T = TypeVar("T", bound="Bound")


@_attrs_define
class Bound:
    """
    Attributes:
        label (str | Unset):
        data (BoundData | Unset):
        page (float | Unset):
        x (float | Unset):
        y (float | Unset):
        width (float | Unset):
        height (float | Unset):
    """

    label: str | Unset = UNSET
    data: BoundData | Unset = UNSET
    page: float | Unset = UNSET
    x: float | Unset = UNSET
    y: float | Unset = UNSET
    width: float | Unset = UNSET
    height: float | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        label = self.label

        data: dict[str, Any] | Unset = UNSET
        if not isinstance(self.data, Unset):
            data = self.data.to_dict()

        page = self.page

        x = self.x

        y = self.y

        width = self.width

        height = self.height

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if label is not UNSET:
            field_dict["label"] = label
        if data is not UNSET:
            field_dict["data"] = data
        if page is not UNSET:
            field_dict["page"] = page
        if x is not UNSET:
            field_dict["x"] = x
        if y is not UNSET:
            field_dict["y"] = y
        if width is not UNSET:
            field_dict["width"] = width
        if height is not UNSET:
            field_dict["height"] = height

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        from ..models.bound_data import BoundData

        d = dict(src_dict)
        label = d.pop("label", UNSET)

        _data = d.pop("data", UNSET)
        data: BoundData | Unset
        if isinstance(_data, Unset):
            data = UNSET
        else:
            data = BoundData.from_dict(_data)

        page = d.pop("page", UNSET)

        x = d.pop("x", UNSET)

        y = d.pop("y", UNSET)

        width = d.pop("width", UNSET)

        height = d.pop("height", UNSET)

        bound = cls(
            label=label,
            data=data,
            page=page,
            x=x,
            y=y,
            width=width,
            height=height,
        )

        bound.additional_properties = d
        return bound

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
